//Written by: Holguer A Becerra
//ECE 31289 UPB-2014-I
//Semillero ADT UPB Bucaramanga
//Based on Xilinx examples


//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module HDMI_TMDS(

	//////////// CLOCK //////////
	CLOCK_50,
	R,G,B,C
	//R_n,G_n,B_n,C_n
);

//=======================================================
//  PARAMETER declarations
//=======================================================

//=======================================================
//  PORT declarations
//=======================================================

//////////// CLOCK //////////
input 		          	 	CLOCK_50;

output R,G,B,C;//,R_n,G_n,B_n,C_n;

//=======================================================
//  REG/WIRE declarations
//=======================================================
wire [7:0] red, green, blue;
wire pixclk,pixclk2,pixclk_global;
wire pixclkx5,pixclkx5_global;
wire pixclkx5_not,pixclkx5_not_global;
wire reset;
wire reset2;

wire [11:0] CounterX, CounterY;
wire hSync, vSync, DrawArea;
wire [9:0] TMDS_red, TMDS_green, TMDS_blue;

//=======================================================
//  Structural coding
//=======================================================


parameter VIDEO_MODE = "VGA";
//parameter VIDEO_MODE = "SVGA";
//paameter VIDEO_MODE = "XGA";
//parameter VIDEO_MODE = "WXGA";
//parameter VIDEO_MODE = "WXGA2";
//parameter VIDEO_MODE = "HDTV720P";
//parameter VIDEO_MODE = "HD";
//parameter VIDEO_MODE = "HDTV1080P";


//parameter VIDEO_DEMO = "BARS";
parameter VIDEO_DEMO = "BREAKOUT_GAME";


// video mode
generate
	if (VIDEO_MODE == "VGA")
	 begin
	 	pll_vga pll_1
		(	
			.areset(1'b0) ,	// input  areset_sig
			.inclk0(CLOCK_50) ,	// input  inclk0_sig
			.c0(pixclk) ,	// output  c0_sig
			.locked(reset2) 	// output  locked_sig
		);
		pll_tx_cyclone4_vga pll_2
		(
			.areset(~reset2) ,	// input  areset_sig
			.inclk0(pixclk) ,	// input  inclk0_sig
			.c0(pixclk2) ,	// output  c0_sig
			.c1(pixclkx5) ,	// output  c1_sig
			.locked(reset) 	// output  locked_sig
		);
	 end
	else if (VIDEO_MODE == "SVGA")
	 begin
	  	pll_svga pll_1
		(
			.areset(1'b0) ,	// input  areset_sig
			.inclk0(CLOCK_50) ,	// input  inclk0_sig
			.c0(pixclk) ,	// output  c0_sig
			.locked(reset2) 	// output  locked_sig
		);
	 	pll_tx_cyclone4_svga pll_2
		(
			.areset(~reset2) ,	// input  areset_sig
			.inclk0(pixclk) ,	// input  inclk0_sig
			.c0(pixclk2) ,	// output  c0_sig
			.c1(pixclkx5) ,	// output  c1_sig
			.locked(reset) 	// output  locked_sig
		);
	 end
	else if (VIDEO_MODE == "XGA") 
	 begin
	  pll_xga pll_1
		(
			.areset(1'b0) ,	// input  areset_sig
			.inclk0(CLOCK_50) ,	// input  inclk0_sig
			.c0(pixclk) ,	// output  c0_sig
			.locked(reset2) 	// output  locked_sig
		);
		pll_tx_cyclone4_xga pll_2
		(
			.areset(~reset2) ,	// input  areset_sig
			.inclk0(pixclk) ,	// input  inclk0_sig
			.c0(pixclk2) ,	// output  c0_sig
			.c1(pixclkx5) ,	// output  c1_sig
			.locked(reset) 	// output  locked_sig
		);
	 end
	else if (VIDEO_MODE == "WXGA") 
	 begin
	  pll_wxga pll_1
		(
			.areset(1'b0) ,	// input  areset_sig
			.inclk0(CLOCK_50) ,	// input  inclk0_sig
			.c0(pixclk) ,	// output  c0_sig
			.locked(reset2) 	// output  locked_sig
		);
		pll_tx_cyclone4_wxga pll_2
		(
			.areset(~reset2) ,	// input  areset_sig
			.inclk0(pixclk) ,	// input  inclk0_sig
			.c0(pixclk2) ,	// output  c0_sig
			.c1(pixclkx5) ,	// output  c1_sig
			.locked(reset) 	// output  locked_sig
		);
	 end 
	else if (VIDEO_MODE == "WXGA2") 
	 begin
	  pll_wxga2 pll_1
		(
			.areset(1'b0) ,	// input  areset_sig
			.inclk0(CLOCK_50) ,	// input  inclk0_sig
			.c0(pixclk) ,	// output  c0_sig
			.locked(reset2) 	// output  locked_sig
		);
		pll_tx_cyclone4_wxga2 pll_2
		(
			.areset(~reset2) ,	// input  areset_sig
			.inclk0(pixclk) ,	// input  inclk0_sig
			.c0(pixclk2) ,	// output  c0_sig
			.c1(pixclkx5) ,	// output  c1_sig
			.locked(reset) 	// output  locked_sig
		);
	 end  
	else if(VIDEO_MODE == "HDTV720P") 
	 begin
	  pll_hd pll_1
		(
			.areset(1'b0) ,	// input  areset_sig
			.inclk0(CLOCK_50) ,	// input  inclk0_sig
			.c0(pixclk) ,	// output  c0_sig
			.locked(reset2) 	// output  locked_sig
		);
		pll_tx_cyclone4_hd pll_2
		(
			.areset(~reset2) ,	// input  areset_sig
			.inclk0(pixclk) ,	// input  inclk0_sig
			.c0(pixclk2) ,	// output  c0_sig
			.c1(pixclkx5) ,	// output  c1_sig
			.locked(reset) 	// output  locked_sig
		);
	 end
	 else if(VIDEO_MODE == "HDTV1080P") 
	 begin
	  pll_HDTV1080P pll_1
		(
			.areset(1'b0) ,	// input  areset_sig
			.inclk0(CLOCK_50) ,	// input  inclk0_sig
			.c0(pixclk) ,	// output  c0_sig
			.locked(reset2) 	// output  locked_sig
		);
		pll_tx_cyclone4_HDTV1080P pll_2
		(
			.areset(~reset2) ,	// input  areset_sig
			.inclk0(pixclk) ,	// input  inclk0_sig
			.c0(pixclk2) ,	// output  c0_sig
			.c1(pixclkx5) ,	// output  c1_sig
			.locked(reset) 	// output  locked_sig
		);
	 end
	 else if(VIDEO_MODE == "HD") 
	 begin
	  pll_hd_hd pll_1
		(
			.areset(1'b0) ,	// input  areset_sig
			.inclk0(CLOCK_50) ,	// input  inclk0_sig
			.c0(pixclk) ,	// output  c0_sig
			.locked(reset2) 	// output  locked_sig
		);
		pll_tx_cyclone4_hd_hd pll_2
		(
			.areset(~reset2) ,	// input  areset_sig
			.inclk0(pixclk) ,	// input  inclk0_sig
			.c0(pixclk2) ,	// output  c0_sig
			.c1(pixclkx5) ,	// output  c1_sig
			.locked(reset) 	// output  locked_sig
		);
	 end
endgenerate	 


//Global Clocks
global_clk	global_clk_inst1 (
	.inclk ( pixclk2 ),
	.outclk ( pixclk_global )
	);

global_clk	global_clk_inst2 (
	.inclk ( pixclkx5 ),
	.outclk ( pixclkx5_global )
);

global_clk	global_clk_inst3 (
	.inclk ( ~pixclkx5 ),
	.outclk ( pixclkx5_not_global )
);


// Video Sync Generator
timing_generator #(.VIDEO_MODE(VIDEO_MODE))
timing_generator_inst  
(
	.VGA_HSYNC(vSync) ,	// output  VGA_HSYNC_sig
	.VGA_VSYNC(hSync) ,	// output  VGA_VSYNC_sig
	.de(DrawArea) ,	// output  de_sig
	.bgnd_hcount(CounterX),
	.bgnd_vcount(CounterY),
	.pclk(pixclk_global), 	// output  pclk_sig
	.reset(~reset)
);  


wire [1:0]format;
generate
if(VIDEO_MODE == "HDTV1080P") 
begin
	assign format[1:0]=2'b01;
end
else
begin
	assign format[1:0]=2'b00;
end
endgenerate

generate
	if(VIDEO_DEMO== "BARS")
	begin
	 // color generator
	 hdcolorbar clrbar(
		 .i_clk_74M(pixclk_global),
		 .i_rst(~reset),
		 .i_hcnt(CounterX),
		 .i_vcnt(CounterY),
		 .baronly(1'b0),
		 .i_format(format[1:0]),
		 .o_r(red),
		 .o_g(green),
		 .o_b(blue)
	  );
	  
	end
	else if(VIDEO_DEMO== "BREAKOUT_GAME")
	begin
		assign red[3:0]=red[7:4];
		assign green[3:0]=green[7:4];
		assign blue[3:0]=blue[7:4];
		
		break_out_Game break_out_Game_inst
		(
			.reset(1'b0), 
			.pixclk(pixclk_global) ,	// input  pixclk_sig
			.inDisplayArea(DrawArea) ,	// input  inDisplayArea_sig
			.CounterX(CounterX[9:0]) ,	// input [9:0] CounterX_sig
			.CounterY(CounterY[8:0]) ,	// input [8:0] CounterY_sig
			.vga_R(red[7:4]) ,	// output [3:0] vga_R_sig
			.vga_G(green[7:4]) ,	// output [3:0] vga_G_sig
			.vga_B(blue[7:4]) ,	// output [3:0] vga_B_sig
			.KEY(2'b00) 	// input [1:0] KEY_sig
		);
	end
endgenerate  
  
  
/////////TMDS ENCODER

defparam encode_blue.CHANNEL = "BLUE";
encode encode_blue
(
	.clkin(pixclk_global) ,	// input  clkin_sig
	.rstin(~reset) ,	// input  rstin_sig
	.vdin(blue[7:0]) ,	// input [7:0] vdin_sig
	.adin(4'd0) ,	// input [3:0] adin_sig
	.c0(hSync) ,	// input  c0_sig
	.c1(VSync) ,	// input  c1_sig
	.vde(DrawArea) ,	// input  vde_sig
	.ade(1'b0) ,	// input  ade_sig
	.dout(TMDS_blue[9:0]) 	// output [9:0] dout_sig
);



defparam encode_green.CHANNEL = "GREEN";
encode encode_green
(
	.clkin(pixclk_global) ,	// input  clkin_sig
	.rstin(~reset) ,	// input  rstin_sig
	.vdin(green[7:0]) ,	// input [7:0] vdin_sig
	.adin(4'd0) ,	// input [3:0] adin_sig
	.c0(1'b0) ,	// input  c0_sig
	.c1(c1_sig) ,	// input  c1_sig
	.vde(DrawArea) ,	// input  vde_sig
	.ade(1'b0) ,	// input  ade_sig
	.dout(TMDS_green[9:0]) 	// output [9:0] dout_sig
);


defparam encode_red.CHANNEL = "RED";
encode encode_red
(
	.clkin(pixclk_global) ,	// input  clkin_sig
	.rstin(~reset) ,	// input  rstin_sig
	.vdin(red[7:0]) ,	// input [7:0] vdin_sig
	.adin(4'd0) ,	// input [3:0] adin_sig
	.c0(1'b0) ,	// input  c0_sig
	.c1(1'b0) ,	// input  c1_sig
	.vde(DrawArea) ,	// input  vde_sig
	.ade(1'b0) ,	// input  ade_sig
	.dout(TMDS_red[9:0]) 	// output [9:0] dout_sig
);



//serializers
wire [1:0]ddio_red;
wire [1:0]ddio_green;
wire [1:0]ddio_blue;
simple_serializer ser_blue
(
	.pclkx5(pixclkx5_global) ,	// input  pclkx5_sig
	.pclkx5_not(pixclkx5_not_global) ,	// input  pclkx5_not_sig
	.TMDS_red(TMDS_red) ,	// input [9:0] TMDS_red_sig
	.TMDS_green(TMDS_green) ,	// input [9:0] TMDS_green_sig
	.TMDS_blue(TMDS_blue) ,	// input [9:0] TMDS_blue_sig
	.ser_red(ddio_red) ,	// output [1:0] ser_red_sig
	.ser_green(ddio_green) ,	// output [1:0] ser_green_sig
	.ser_blue(ddio_blue) 	// output [1:0] ser_blue_sig
);



//DDDIO

//wire red_component;
DDIO	red_com (
	.datain_h ( ddio_red[0] ),
	.datain_l ( ddio_red[1] ),
	.outclock ( pixclkx5_global ),
	.dataout ( R  )
	);

DDIO	green_com (
	.datain_h ( ddio_green[0] ),
	.datain_l ( ddio_green[1] ),
	.outclock ( pixclkx5_global ),
	.dataout ( G )
	);
	
DDIO	blue_com (
	.datain_h ( ddio_blue[0] ),
	.datain_l ( ddio_blue[1] ),
	.outclock ( pixclkx5_global ),
	.dataout ( B )
	);
	
DDIO	clk_com (
	.datain_h ( 1),
	.datain_l ( 0 ),
	.outclock ( pixclk_global ),
	.dataout ( C )
);

endmodule



