// Written by: Holguer A Becerra

module break_out_Game( input reset,input pixclk,input inDisplayArea,input [9:0]CounterX, input[8:0]CounterY, output reg [3:0]vga_R, output reg [3:0]vga_G, output reg [3:0]vga_B, input [1:0]KEY);

///
//contadores en X
wire speed_up_event;
wire speed_down_event;


//contador para nivel y tamao de barra

reg [9:0]bar;
wire [9:0]barsize;
assign barsize=bar;
//pong
 // symbolic state declaration
localparam  [1:0]
	newgame = 2'b00,
	play    = 2'b01,
	newball = 2'b10,
	over    = 2'b11;

// signal declaration
reg [1:0] state_reg, state_next;
wire [1:0]btn={~KEY[0],~KEY[1]};
wire graph_on,gra_on2,gra_on3,gra_on4,gra_on5, hit, miss,hit2,miss2,hit3,miss3,hit4,hit5;
wire [3:0] text_on;
wire [2:0] graph_rgb, text_rgb,graph_rgb2,graph_rgb3,graph_rgb4,graph_rgb5;
wire [3:0] dig0, dig1;
reg d_inc, d_clr, timer_start;
reg gra_still, gra_still2,gra_still3=1'b0;
wire timer_tick, timer_up;
reg [1:0] ball_reg, ball_next;
wire contador,contadorclc;
wire contador1,contador2,contador3;

assign contadorclc=d_clr;

//news gra
wire hit6;
wire gra_on6,gra_on7,hit7;
wire gra_on8,gra_on9,gra_on10,gra_on11,gra_on12;
wire [2:0] graph_rgb6,graph_rgb7;

wire [9:0]deltax;
wire [9:0]direcc,direcc2,direcc3,direcc4,direcc5,direcc6,direcc7,direcc8,direcc9;
wire dire;
reg gravis=1'b1; //ver ladrillo1 
reg gravis1=1'b1; //ver ladrillo2 
reg gravis2=1'b1; //ver ladrillo3 
reg gravis3=1'b1; //ver ladrillo4 
reg gravis4=1'b1; //ver ladrillo5 
reg gravis5=1'b1; //ver ladrillo6 
reg gravis6=1'b1; //ver ladrillo7 
reg gravis7=1'b1; //ver ladrillo8 
reg gravis8=1'b1; //ver ladrillo9 
reg gravis9=1'b1; //ver ladrillo10 
reg gravis10=1'b1; //ver ladrillo11 
 /////////////////////////////
////////////////////////////////////////////////////////////////////////

////////////////
// Codigo para generar cuadrilla =D
wire border = (CounterX[9:0]==0) || (CounterX[2:0]==3'd5) || (CounterY[2:0]==3'd5) || (CounterY[8:0]==0);

wire [9:0]posXball;
wire [8:0]posYball;
wire [2:0]colordeladrillos;
wire showlad;


//ladrillos
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// ladrillo blanco
ladrillos instae (
    .clk(~pixclk), 
    .reset(reset), 
    .btn(2'b01), 
    .pix_x(CounterX[9:0]), 
    .pix_y(CounterY[8:0]), 
    .gra_still(~gravis), 
	 //.gra_still(SW[0]), 
	 .on(gravis),
    .graph_on(graph_on2), 
    .hit(hit2), 
    .miss(miss2),
	 .gracolor(3'b111),	 //blanco
    .graph_rgb(graph_rgb2),
	 .ball_x(posXball), //coordenada x del balon
	 .ball_y(posYball), //coordenada y del balon
	 .direccion(deltax),//direccion anterior o actual
	 .newdir(direcc),//direccion despues de golpeada la barra con la bola OUT
	 .BAR_X_L(10'd50),
	 .BAR_X_R(10'd53),
	 .BAR_V(10'd6),
	 .BAR_Y_SIZE(barsize)// tamao de la barra disminuye a partir del puntaje
 );
 
 // ladrillo azul
ladrillos instae2 (
    .clk(~pixclk), 
    .reset(reset), 
    .btn(2'b10), 
    .pix_x(CounterX[9:0]), 
    .pix_y(CounterY[8:0]), 
    .gra_still(~gravis1), 
	 .on(gravis1),
    .graph_on(graph_on3), 
    .hit(hit3), 
    .miss(miss3),
	 .gracolor(3'b001),	 //blue
    .graph_rgb(graph_rgb3),
	 .ball_x(posXball), //coordenada x del balon
	 .ball_y(posYball), //coordenada y del balon
	 .direccion(deltax),//direccion anterior o actual
	 .newdir(direcc2),//direccion despues de golpeada la barra con la bola OUT
	 .BAR_X_L(10'd70),
	 .BAR_X_R(10'd73),
	 .BAR_V(10'd5),
	 .BAR_Y_SIZE(barsize)
 );
 
  // ladrillo negro
ladrillos instae3 (
    .clk(~pixclk), 
    .reset(reset), 
    .btn(2'b01), 
    .pix_x(CounterX[9:0]), 
    .pix_y(CounterY[8:0]), 
    .gra_still(~gravis2), 
	 .on(gravis2),
    .graph_on(graph_on4), 
    .hit(hit4), 
    .miss(),
	 .gracolor(3'b000),	 //black
    .graph_rgb(graph_rgb4),
	 .ball_x(posXball), //coordenada x del balon
	 .ball_y(posYball), //coordenada y del balon
	 .direccion(deltax),//direccion anterior o actual
	 .newdir(direcc3),//direccion despues de golpeada la barra con la bola OUT
	 .BAR_X_L(10'd90),
	 .BAR_X_R(10'd93),
	 .BAR_V(10'd4),
	 .BAR_Y_SIZE(barsize)
 );

// ladrillo blanco
ladrillos instae4 (
    .clk(~pixclk), 
    .reset(reset), 
    .btn(2'b10), 
    .pix_x(CounterX[9:0]), 
    .pix_y(CounterY[8:0]), 
    .gra_still(~gravis3), 
	 .on(gravis3),
    .graph_on(graph_on5), 
    .hit(hit5), 
    .miss(),
	 .gracolor(3'b111),	 //white
    .graph_rgb(graph_rgb5),
	 .ball_x(posXball), //coordenada x del balon
	 .ball_y(posYball), //coordenada y del balon
	 .direccion(deltax),//direccion anterior o actual
	 .newdir(direcc4),//direccion despues de golpeada la barra con la bola OUT
	 .BAR_X_L(10'd110),
	 .BAR_X_R(10'd113),
	 .BAR_V(10'd3),
	 .BAR_Y_SIZE(barsize)
 );


// ladrillo magneta
ladrillos instae5 (
    .clk(~pixclk), 
    .reset(reset), 
    .btn(2'b01), 
    .pix_x(CounterX[9:0]), 
    .pix_y(CounterY[8:0]), 
    .gra_still(~gravis4), 
	 .on(gravis4),
    .graph_on(graph_on6), 
    .hit(hit6), 
    .miss(),
	 .gracolor(3'b011),	 //magneta
    .graph_rgb(graph_rgb6),
	 .ball_x(posXball), //coordenada x del balon
	 .ball_y(posYball), //coordenada y del balon
	 .direccion(deltax),//direccion anterior o actual
	 .newdir(direcc5),//direccion despues de golpeada la barra con la bola OUT
	 .BAR_X_L(10'd120),
	 .BAR_X_R(10'd123),
	 .BAR_V(10'd2),
	 .BAR_Y_SIZE(barsize)
 );

// ladrillo rojo obstaculo
ladrillos instae6 (
    .clk(~pixclk), 
    .reset(reset), 
    .btn(2'b10), 
    .pix_x(CounterX[9:0]), 
    .pix_y(CounterY[8:0]), 
    .gra_still(~gravis5), 
	 .on(gravis5),
    .graph_on(graph_on7), 
    .hit(hit7), 
    .miss(),
	 .gracolor(3'b100),	 //rojo
    .graph_rgb(graph_rgb7),
	 .ball_x(posXball), //coordenada x del balon
	 .ball_y(posYball), //coordenada y del balon
	 .direccion(deltax),//direccion anterior o actual
	 .newdir(direcc6),//direccion despues de golpeada la barra con la bola OUT
	 .BAR_X_L(10'd310),
	 .BAR_X_R(10'd311),
	 .BAR_V(10'd2),
	 .BAR_Y_SIZE(10'd80)
 );


///////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
  // instantiate text module
   pong_text text_unit
      (.clk(~pixclk),
       .pix_x(CounterX[9:0]), 
		 .pix_y(CounterY[8:0]), 
       .dig0(dig0), .dig1(dig1), .ball(ball_reg),
       .text_on(text_on), .text_rgb(text_rgb));
  // instantiate graph module
   pong_graph graph_unit
      (.clk(~pixclk), .reset(reset), .btn(btn),
       .pix_x(CounterX[9:0]), 
		 .pix_y(CounterY[8:0]), 
       .gra_still(gra_still), .hit(hit), .miss(miss),
       .graph_on(graph_on), .graph_rgb(graph_rgb),.ball_x(posXball),.ball_y(posYball),
		 .x_delta(deltax),// mantiene informado al modulo ladrillo sobre la direcion actual
		 //.dir({~gravis1,~gravis}),// cada vez que hay hit2 se cambia la direccion por direcc o la nueva direccion
		 .dir(hit2),// cada hit se cambia de direccio
		 .dir1(hit3),
		 .dir2(hit4),
		 .dir3(hit5),
		 .dir4(hit6),
		 .dir5(hit7),
		 .newdirec(direcc),//direccion despues de golpeada la barra con la bola IN
		 .newdirec2(direcc2),//direccion despues de golpeada la barra con la bola IN
		 .newdirec3(direcc3),
		 .newdirec4(direcc4),
		 .newdirec5(direcc5),
		 .newdirec6(direcc6)
		 
		 );
		 
////##############################################################################
////##### Necesario para el conteo del marcador en cada hit
	assign contador=hit2 | hit3 ;
	assign contador1=contador |hit4;
	assign contador2= contador1 | hit5;
	assign contador3= contador2 | hit6 ;
////##############################################################################	
   // instantiate 2 sec timer
   // 60 Hz tick
   assign timer_tick = (CounterX==0) && (CounterY==0);
   timer timer_unit
      (.clk(~pixclk), .reset(reset), .timer_tick(timer_tick),
       .timer_start(timer_start), .timer_up(timer_up));
   // instantiate 2-digit decade counter
   m100_counter counter_unit
      (.clk(~pixclk), .reset(reset), .d_inc(contador3), .d_clr(contadorclc),
       .dig0(dig0), .dig1(dig1));
   //=======================================================
   // FSMD
   //=======================================================
   // FSMD state & data registers
	
    always @(posedge pixclk, posedge reset)
	 begin
       if (reset)
          begin
             state_reg <= newgame;
             ball_reg <= 0;
          end
       else
          begin
            state_reg <= state_next;
            ball_reg <= ball_next;
          end
		end
		

			 
   
   always @(posedge pixclk)
   begin
      gra_still <= 1'b1;
      timer_start <= 1'b0;
      d_inc <= 1'b0;
      d_clr <= 1'b0;
      state_next <= state_reg;
      ball_next <= ball_reg;
      case (state_reg)
         newgame:
            begin
               ball_next <= 2'b11; // three balls
               d_clr <= 1'b1;      // clear score
               if ( btn!= 2'b00)  // button pressed
                  begin
                     state_next <= play;
                     ball_next <= ball_reg - 1;
                  end
            end
         play:
            begin
               gra_still <= 1'b0;  // animated screen
					gra_still2 <= 1'b0;  // animated screen
               if (hit)
					begin
                  d_inc <= 1'b1;   // increment score
						
					end	
				   else if (miss)
                  begin
                     if (ball_reg==0)
                        state_next <= over;
                     else
                        state_next <= newball;
                     timer_start <= 1'b1;  // 2 sec timer
                     ball_next <= ball_reg - 1;
                  end
            end
         newball:
            // wait for 2 sec and until button pressed
            if (timer_up && (btn != 2'b00))
                state_next <= play;
         over:
            // wait for 2 sec to display game over
            if (timer_up)
				begin
                //{state_next,gravis,gravis1} <= {newgame,2'b11};
					 state_next <= newgame;
					 
				end	 
       endcase
    end
	 
////////////===============================================================	 
	 //cada vez que se presente un hit
	 
	 //ladrillo1
	 always@(posedge hit2,posedge d_clr)
	 begin
	  if(d_clr) gravis<=1'b1;
	  else gravis<=1'b0;
	 end
	 //ladrillo2
	 always@(posedge hit3, posedge d_clr)
	 begin
	 if(d_clr)gravis1<=1'b1;
	 else gravis1<=1'b0;
	 end
	 
	 //ladrillo3
	 always@(posedge hit4, posedge d_clr)
	 begin
	 if(d_clr)gravis2<=1'b1;
	 else gravis2<=1'b0;
	 end
	 //ladrillo4
	 always@(posedge hit5, posedge d_clr)
	 begin
	 if(d_clr)gravis3<=1'b1;
	 else gravis3<=1'b0;
	 end
	 //ladrillo5
	 always@(posedge hit6, posedge d_clr)
	 begin
	 if(d_clr)gravis4<=1'b1;
	 else gravis4<=1'b0;
	 end



	 always@(posedge pixclk)
	 begin
	   case({dig1,dig0}) // de acuerdo al puntaje se multiplexa el tamao de la barras
		8'b00000000:bar<=10'd70;
		8'b00000001:bar<=10'd30;
		8'b00000010:bar<=10'd15;
		8'b00000011:bar<=10'd8;
		8'b00000100:bar<=10'd5;
		8'b00000101:bar<=10'd4;
		default:bar<=bar;
		endcase
	 end
	
//=======================================================
   // rgb multiplexing circuit
   //=======================================================
	
   always @(posedge pixclk)
	begin
	if(!inDisplayArea)
	begin
		vga_R <= 4'd0;
		vga_G <= 4'd0;
		vga_B <= 4'd0;
	end
	else
	begin
            // display score, rule, or game over
         if (text_on[3] ||
               ((state_reg==newgame) && text_on[1]) || // rule
               ((state_reg==over) && text_on[0]))
				begin
				vga_R <=  {border &  text_rgb[2],border,2'b00};
				vga_G <= { text_rgb[1],1'b1,2'b00};//4'b0000;//{1'b0,border,2'b00};//4'b000;//{G & inDisplayArea,3'b000};
				vga_B <= { text_rgb[0], text_rgb[0], text_rgb[0], text_rgb[0]};//4'b0000;//{B & inDisplayArea,3'b000};
				end
         else if (graph_on)  // display graph
		      begin
				vga_R <=  {graph_rgb[2], graph_rgb[2],graph_rgb[2], graph_rgb[2]};
				vga_G <= { {4{graph_rgb[1]}}};//4'b0000;//{1'b0,border,2'b00};//4'b000;//{G & inDisplayArea,3'b000};
				vga_B <= { {4{graph_rgb[0]}}};//4'b0000;//{B & inDisplayArea,3'b000};
				end
			else if (graph_on2)  // ladrillo rojo
		      begin
				vga_R <= { graph_rgb2[2], graph_rgb2[2], graph_rgb2[2], graph_rgb2[2]};
				vga_G <= { graph_rgb2[1], graph_rgb2[1], graph_rgb2[1], graph_rgb2[1]};//4'b0000;//{1'b0,border,2'b00};//4'b000;//{G & inDisplayArea,3'b000};
				vga_B <= { graph_rgb2[0], graph_rgb2[0], graph_rgb2[0], graph_rgb2[0]};//4'b0000;//{B & inDisplayArea,3'b000};
				
				end
			else if (graph_on3)  // ladrillo azul
		      begin
				vga_R <=  { graph_rgb3[2],3'b000};
				vga_G <= { graph_rgb3[1],3'b000};//4'b0000;//{1'b0,border,2'b00};//4'b000;//{G & inDisplayArea,3'b000};
				vga_B <= { graph_rgb3[0], graph_rgb3[0], graph_rgb3[0], graph_rgb3[0]};//4'b0000;//{B & inDisplayArea,3'b000};
				end
   
   		else if (graph_on4)  // ladrillo nego
		      begin
				vga_R <=  { graph_rgb4[2],3'b000};
				vga_G <= { graph_rgb4[1],3'b000};//4'b0000;//{1'b0,border,2'b00};//4'b000;//{G & inDisplayArea,3'b000};
				vga_B <= { graph_rgb4[0],3'b000};//4'b0000;//{B & inDisplayArea,3'b000};
				end

   		else if (graph_on5)  // ladrillo blanco
     
		      begin
				vga_R <= { graph_rgb5[2], graph_rgb5[2], graph_rgb5[2], graph_rgb5[2]};
				vga_G <= { graph_rgb5[1], graph_rgb5[1], graph_rgb5[1], graph_rgb5[1]};//4'b0000;//{1'b0,border,2'b00};//4'b000;//{G & inDisplayArea,3'b000};
				vga_B <= { graph_rgb5[0], graph_rgb5[0], graph_rgb5[0], graph_rgb5[0]};//4'b0000;//{B & inDisplayArea,3'b000};
				end
   		else if (graph_on6)  // ladrillo magneta
		      begin
				vga_R <= { graph_rgb6[2],3'b000};
				vga_G <= { graph_rgb6[1], graph_rgb6[1], graph_rgb6[1], graph_rgb6[1]};//4'b0000;//{1'b0,border,2'b00};//4'b000;//{G & inDisplayArea,3'b000};
				vga_B <= { graph_rgb6[0], graph_rgb6[0], graph_rgb6[0], graph_rgb6[0]};//4'b0000;//{B & inDisplayArea,3'b000};
				end
      	else if (graph_on7)  // ladrillo rojo
		      begin
				vga_R <=  { graph_rgb7[2], graph_rgb7[2], graph_rgb7[2], graph_rgb7[2]};
				vga_G <= { graph_rgb7[1],3'b000};//4'b0000;//{1'b0,border,2'b00};//4'b000;//{G & inDisplayArea,3'b000};
				vga_B <= { graph_rgb7[0],3'b000};//4'b0000;//{B & inDisplayArea,3'b000};
				end

         else if (text_on[2]) // display logo
			   begin
			   vga_R <=  {border &  text_rgb[2],border ,2'b00};
				vga_G <= { text_rgb[1],2'b00,1'b1};//4'b0000;//{1'b0,border,2'b00};//4'b000;//{G & inDisplayArea,3'b000};
				vga_B <= { text_rgb[0],2'b00,1'b1};//4'b0000;//{B & inDisplayArea,3'b000};
				end
         else
			  begin
			  vga_R <=  {border ,border,2'b00};
			  vga_G <= 	{1'b1,1'b1,2'b00};
			  vga_B <=  {3'b000,1'b1};//{B & inDisplayArea,3'b000};
			  end
		end	  
	end		  
			 

endmodule

