`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    17:14:23 11/15/2009 
// Design Name: 
// Module Name:    ladrillos 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
// Listing 14.7
module ladrillos 
   (
    input wire clk, reset,
    input wire [1:0] btn,
    input wire [9:0] pix_x,
	 input wire [8:0] pix_y,
    input wire gra_still,
    output wire graph_on,
    output reg hit, miss,
    output reg [2:0] graph_rgb,
	 input wire [9:0]ball_x,
	 input wire [8:0]ball_y,
	 input on,
	 input wire [9:0]direccion,
	 output reg [9:0]newdir,
	 input wire [2:0]gracolor,
	 input wire [9:0]BAR_X_L,
	 input wire [9:0]BAR_X_R,
	 input wire [9:0]BAR_V,
	 input wire [9:0]BAR_Y_SIZE
);

// x, y coordinates (0,0) to (639,479)
   localparam MAX_X = 640;
   localparam MAX_Y = 480;
   wire refr_tick;
   //--------------------------------------------
   // vertical strip as a wall
   //--------------------------------------------
   // wall left, right boundary
   localparam WALL_X_L = 32;
   localparam WALL_X_R = 35;
   //--------------------------------------------
   // right vertical bar
   //--------------------------------------------
   // bar left, right boundary
   //localparam BAR_X_L = 200;
   //localparam BAR_X_R = 203;
   // bar top, bottom boundary
   wire [9:0] bar_y_t, bar_y_b;
   //localparam BAR_Y_SIZE = 30;
   // register to track top boundary  (x position is fixed)
   reg [8:0] bar_y_reg, bar_y_next;
   // bar moving velocity when the button are pressed
   //localparam BAR_V = 4;
   //--------------------------------------------
   // square ball
   //--------------------------------------------
   localparam BALL_SIZE = 8;
   // ball left, right boundary
   wire [9:0] ball_x_l, ball_x_r;
   // ball top, bottom boundary
   wire [9:0] ball_y_t, ball_y_b;
   // reg to track left, top position
   reg [9:0] ball_x_reg, ball_y_reg;
   wire [9:0] ball_x_next, ball_y_next;
   
   // ball velocity can be pos or neg)
   localparam BALL_V_P = 2;
   localparam BALL_V_N = -2;
   
   //--------------------------------------------
   // object output signals
   //--------------------------------------------
   wire bar_on;
   wire [2:0] bar_rgb;
  
   
   // registers
   always @(posedge clk, posedge reset)
      if (reset)
         begin
            bar_y_reg <= 0;
         end   
      else
         begin
            bar_y_reg <= bar_y_next;
         end   

   // refr_tick: 1-clock tick asserted at start of v-sync
   //       i.e., when the screen is refreshed (60 Hz)
   assign refr_tick = (pix_y==481) && (pix_x==0);
   
   
   //--------------------------------------------
   // right vertical bar
   //--------------------------------------------
   // boundary
   assign bar_y_t = bar_y_reg;
   assign bar_y_b = bar_y_t + BAR_Y_SIZE - 1;
	
	//
   //habilitar o deshabilitar barra
	
	reg sino;
	always@*
	begin
		case(on)
		1'b0:sino=1'b0;
		1'b1:sino=(BAR_X_L<=pix_x) && (pix_x<=BAR_X_R) &&
                   (bar_y_t<=pix_y) && (pix_y<=bar_y_b); 
		endcase
	end
	assign bar_on=sino;
   // bar rgb output
   assign bar_rgb = gracolor; // red
   // new bar y-position
	always @*
   begin
      bar_y_next = bar_y_reg; // no move
      if (gra_still) // initial position of paddle
        // bar_y_next = (MAX_Y-BAR_Y_SIZE)/2;
		   //bar_y_next = MAX_Y;
			bar_y_next = MAX_Y;
		
      else if (refr_tick)
         if (btn[1])
            bar_y_next = bar_y_reg + BAR_V; // move down
         else if (btn[0]) 
            bar_y_next = bar_y_reg - BAR_V; // move up
   end 
   //--------------------------------------------
   // square ball
   //--------------------------------------------
   // boundary
   assign ball_x_l = ball_x;
   assign ball_y_t = ball_y;
   assign ball_x_r = ball_x_l + BALL_SIZE - 1;
   assign ball_y_b = ball_y_t + BALL_SIZE - 1;
   
   //barra

   always @(posedge clk)   
   begin
   if ((BAR_X_L<=ball_x_r) && (ball_x_r<=BAR_X_R) &&
               (bar_y_t<=ball_y_b) && (ball_y_t<=bar_y_b))
         begin
			  if(direccion==10'b1111111110)
			   begin
				 newdir<=10'b0000000010;
				 hit <= 1'b1;
				end
			  else
			   begin
				 newdir<=10'b1111111110;
				 hit <= 1'b1;
				end
			  
         end
      else
         begin		
			 newdir<=direccion;
		    hit<=1'b0;
			end
   end 

   //--------------------------------------------
   // rgb multiplexing circuit
   //--------------------------------------------
   always @* 
      if (bar_on)
         graph_rgb = bar_rgb;
      else
            graph_rgb = 3'b110; // yellow background
   // new graphic_on signal
   assign graph_on =  bar_on;

   
	


endmodule
