// Listing 14.8
module m100_counter
   (
    input wire clk, reset,
    input wire d_inc, d_clr,
    output wire [3:0] dig0, dig1
   );

   // signal declaration
   reg [3:0] dig0_reg, dig1_reg, dig0_next, dig1_next;

   // registers
   always @(posedge clk, posedge reset)
      if (reset)
         begin
            dig1_reg <= 0;
            dig0_reg <= 0;
         end
      else
         begin
            dig1_reg <= dig1_next;
            dig0_reg <= dig0_next;
         end

   // next-state logic
   always @(posedge d_inc,posedge d_clr)
   begin
      
      if (d_clr)
         begin
            dig0_next <= 0;
            dig1_next <= 0;
         end
      else if (d_inc)
         if (dig0_reg==9)
            begin
               dig0_next <= 0;
               if (dig1_reg==9)
                  dig1_next <= 0;
               else
                  dig1_next <= dig1_reg + 1;
             end
         else 
				begin// dig0 not 9
					dig0_next <= dig0_reg + 1;
				end
		 else begin
			 dig0_next <= dig0_reg;
			dig1_next <= dig1_reg;
			end
   end
   // output
   assign dig0 = dig0_reg;
   assign dig1 = dig1_reg;

endmodule
