#All functions called through java will package name as its first argument, you may ignore and worry about remaining arguments
use strict;

#new creates a package object with IP Toolbench shared objects as its memebers
sub new
{
      my ($fb, $plugin) = @_;
      my $fb_fm = $fb->getFlowManager("()Laltera/ipbu/flowbase/flowmanager/FlowManagerInterface;");
      $fb_fm = $fb_fm->newWeakGlobalRef();
      my $fb_fm_ui = $fb->getFlowManagerUI("()Laltera/ipbu/flowbase/flowmanager/FlowManagerUIInterface;");
      $fb_fm_ui = $fb_fm_ui->newWeakGlobalRef();
      my $fb_app_res = $fb->getAppResource("()Laltera/ipbu/flowbase/flowmanager/ApplicationResourceManagerInterface;");
      $fb_app_res = $fb_app_res->newWeakGlobalRef();
      my $fb_netlist = $fb->getNetlist("()Laltera/ipbu/flowbase/netlist/NetlistInterface;");
      $fb_netlist = $fb_netlist->newWeakGlobalRef();
      my $fb_report = $fb->getReport("()Laltera/ipbu/flowbase/flowmanager/DebugInterface;");
      $fb_report = $fb_report->newWeakGlobalRef();
      my $fb_plugin_manager = $fb->getPluginManager("()Laltera/ipbu/flowbase/plugin/PluginSynchronizer;");
      $fb_plugin_manager = $fb_plugin_manager->newWeakGlobalRef();
      my $fb_runtime_storage = $fb->getRuntimeStorage("()Laltera/ipbu/flowbase/flowmanager/RuntimeStorageInterface;");
      $fb_runtime_storage = $fb_runtime_storage->newWeakGlobalRef();
      my $fb_global_settings = $fb->getGlobalSettings("()Laltera/ipbu/flowbase/flowmanager/RegistryInterface;");
      $fb_global_settings = $fb_global_settings->newWeakGlobalRef();
      my $fb_netlist_privates = $fb_netlist->getPrivateSection("()Laltera/ipbu/flowbase/netlist/NetlistGlobalPrivateInterface;");
      $fb_netlist_privates = $fb_netlist_privates->newWeakGlobalRef();
      my $fb_netlist_ports =  $fb_netlist->getPortSection("()Laltera/ipbu/flowbase/netlist/NetlistPortInterface;");
      $fb_netlist_ports = $fb_netlist_ports->newWeakGlobalRef();
      my $fb_netlist_constants =  $fb_netlist->getConstantSection("()Laltera/ipbu/flowbase/netlist/NetlistConstantInterface;");
      $fb_netlist_constants = $fb_netlist_constants->newWeakGlobalRef();
      my $fb_fm_state_machine = $fb_fm->getStateMachine("()Laltera/ipbu/flowbase/flowmanager/StateMachineInterface;");
      $fb_fm_state_machine = $fb_fm_state_machine->newWeakGlobalRef();
      my $fb_fm_state_machine_wizard_data = $fb_fm_state_machine->getWizardDataObject("()Laltera/ipbu/flowbase/flowmanager/UserDataExtInterface;");
      $fb_fm_state_machine_wizard_data = $fb_fm_state_machine_wizard_data->newWeakGlobalRef();
      my $this = $plugin->newWeakGlobalRef();
      my $fb_database = $fb->getDATABASE("()Laltera/ipbu/flowbase/DATABASE;");
      $fb_database = $fb_database->newWeakGlobalRef();
      my $fb_flowconstants = $fb->getFlowConstants("()Laltera/ipbu/flowbase/FlowConstants;");
      $fb_flowconstants = $fb_flowconstants->newWeakGlobalRef();
      $fb_fm_state_machine_wizard_data = $fb_fm_state_machine_wizard_data->newWeakGlobalRef();

      return bless
      {
         OBJBASE => $fb,
         FLOW_MANAGER => $fb_fm,
         FLOW_MANAGER_UI => $fb_fm_ui,
         APP_RESOURCE => $fb_app_res,
         RUNTIME_STORAGE => $fb_runtime_storage,
         NETLIST => $fb_netlist,
         PRIVATES => $fb_netlist_privates,
         PORTS => $fb_netlist_ports,
         CONSTANTS => $fb_netlist_constants,
         REPORT => $fb_report,
         GLOBAL_SETTINGS => $fb_global_settings,
         STATE_MACHINE => $fb_fm_state_machine,
         WIZARD_DATA => $fb_fm_state_machine_wizard_data,
         PLUGIN_MANAGER => $fb_plugin_manager,
         DATA_BASE => $fb_database,
         FLOW_CONSTANTS => $fb_flowconstants,
         THIS => $this,

         NODE_ADDED => 1,
         NODE_MODIFIED => 2,
         NODE_REFRESH => 3,
         NODE_DELETED => 4,

         DATA_ADDED => 1,
         DATA_MODIFIED => 2,
         DATA_REFRESH => 3,
         DATA_DELETED => 4,

         ACTION_UPDATE => 0,
         ACTION_INITIALIZED => 11,
         ACTION_UNINITIALIZED => 12,

         ACTION_ACTIVATED => 1001,
         ACTION_DEACTIVATED => 1002,
         ACTION_REFRESH => 1003,

         ACTION_STARTED => 101,
         ACTION_STOPPED => 102,
         ACTION_FAILED => 103,
         ACTION_SUCCEED => 104,
      };
}
sub debug
{
    my (@arg) = @_;
    ePerlCExt::print_debug(@arg);
}

my $ePerl;
sub report
{
    my (@arg) = @_;
    foreach my $ref (@arg)
    {
        my $strRef = Jvm::newStringUTF($ref);
        $ePerl->REPORT->print("(Ljava/lang/String;)V", $strRef);
    }
    $ePerl->REPORT->println("()V");
}

my $plugin_data;
my $wizard;
my $netlist_top;
my $hdl_type;
my $hdl_extension;
my $output_file;
my $cnx_file;
my $coeff_file;
my $coefi_file;
my $params_file;
my $fir_param_file;
my $sub_module;

sub plugin_initialize
{
    my($package, $objbase, $plugin) = @_;
    $ePerl = new($objbase, $plugin);
    $plugin_data = $plugin->getPluginData("()Laltera/ipbu/flowbase/flowmanager/UserDataInterface;");
    $wizard = $plugin_data->get_data_by_path("(Ljava/lang/String;)Ljava/lang/String;", "command");
    $fir_param_file = $plugin_data->get_data_by_path("(Ljava/lang/String;)Ljava/lang/String;", "fir_param_file");
    $sub_module = $plugin_data->get_data_by_path("(Ljava/lang/String;)Ljava/lang/String;", "sub_module");

    my $flowConstants = Jvm::findClass("altera/ipbu/flowbase/FlowConstants");
    my $fieldID = $flowConstants->getStaticFieldID("CMD_NETLISTTOP_KEY", "Ljava/lang/String;");
    my $netlist_key	= $flowConstants->getStaticObjectField($fieldID);
        $netlist_key = $netlist_key->toString("()Ljava/lang/String;");

    $fieldID = $flowConstants->getStaticFieldID("CMD_HDLTYPE_KEY", "Ljava/lang/String;");
    my $hdltype_key = $flowConstants->getStaticObjectField($fieldID);
        $hdltype_key = $hdltype_key->toString("()Ljava/lang/String;");

        $ePerl->debug($netlist_key, " ", $hdltype_key);
    $netlist_top = $ePerl->{PRIVATES}->getValue("(Ljava/lang/String;Ljava/lang/String;)Ljava/lang/String;", $netlist_key, "default_top");
    $hdl_type = uc($ePerl->{PRIVATES}->getValue("(Ljava/lang/String;Ljava/lang/String;)Ljava/lang/String;", $hdltype_key, "VHDL"));

    if($hdl_type eq "VHDL")
    {
        $hdl_extension = ".vhd";
    }
    elsif($hdl_type eq "AHDL")
    {
        $hdl_extension = ".tdf";
    }
    else
    {
        $hdl_extension = ".v";
    }
    $output_file = $objbase->getProjectFilePath("(Ljava/lang/String;)Ljava/lang/String;", "$netlist_top$hdl_extension");
    $cnx_file = $objbase->getProjectFilePath("(Ljava/lang/String;)Ljava/lang/String;", "$netlist_top\.cnx");
    $params_file = $objbase->getProjectFilePath("(Ljava/lang/String;)Ljava/lang/String;", "$netlist_top\_silent_param.txt");

    $coeff_file =  $objbase->getProjectFilePath("(Ljava/lang/String;)Ljava/lang/String;", "$netlist_top\_coef_lst_f.txt");
    $coefi_file =  $objbase->getProjectFilePath("(Ljava/lang/String;)Ljava/lang/String;", "$netlist_top\_coef_lst_i.txt");

    my $core_dir =  $objbase->getCoreFilePath("(Ljava/lang/String;)Ljava/lang/String;", "");
    my $flow_dir =  $objbase->getFlowFilePath("(Ljava/lang/String;)Ljava/lang/String;", "");
    my $jre_exe = $objbase->getJavaFilePath("(Ljava/lang/String;)Ljava/lang/String;", "java");
        if($objbase->isWindows("()Z"))
        {
          $jre_exe = $objbase->getJavaFilePath("(Ljava/lang/String;)Ljava/lang/String;", "javaw");
    }
    $_ = $wizard;
    while(s/%core_dir%/$core_dir/i)
    {

    }
    while(s/%flow_dir%/$flow_dir/i)
    {

    }
    while(s/%java%/$jre_exe/i)
    {

    }
    $wizard = $_;
}

sub plugin_uninitialize
{
    return;
}

sub plugin_start
{
        run_wizard("-silent");
    return;
}

sub plugin_stop
{
    return;
}

sub nodeNotification
{
    my($package, $nodeStr, $nodeData, $action, $source) = @_;
    return;
}
sub nodesRefresh
{
    my @arg = @_;
    return;
}
sub netlistNotification
{
    my @arg = @_;
    return;
}
sub pluginNotification
{
    my @arg = @_;
    return;
}
sub objectNotification
{
    my @arg = @_;
    return;
}


#Functions listed in DefaultPerlUIPlugin replicating functions implemented in BasePluginUIInterfaceObject class
sub plugin_activate
{
        run_wizard("");
}



sub run_wizard
{
            my($wizard_switches) = @_;
        no strict;
                my $portData;
                my $pData;
                my $in_set_block = 0;

        if ($fir_param_file eq "1")
        {
            my $output = 'PARAMOUT';
            unless( open $output, "> $params_file")
            {
            $ePerl->debug("Failed to create $params_file");
            return;
            }

            my $output2 = 'COEFF';
            unless( open $output2, "> $coeff_file")
            {
            $ePerl->debug("Failed to create $coeff_file");
            return;
            }

            my $output3 = 'COEFI';
            unless( open $output3, "> $coefi_file")
            {
            $ePerl->debug("Failed to create $coefi_file");
            return;
            }

            my $netPro = $ePerl->{PRIVATES}->getPluginPrivateSection("(Ljava/lang/String;)Laltera/ipbu/flowbase/netlist/NetlistPrivateInterface;", $ePerl->{THIS}->getPluginId("()Ljava/lang/String;"));
            if(netPro)
            {
            $pData = $netPro->getPrivateData("()Laltera/ipbu/flowbase/flowmanager/UserDataInterface;");
            $portData = $ePerl->{PORTS}->getPortData("()Laltera/ipbu/flowbase/flowmanager/UserDataInterface;");
            my $count = $pData->get_child_count("()I");
            for(my $i = 0; $i < $count; $i++)
            {
                my $child = $pData->get_child("(I)Laltera/ipbu/flowbase/flowmanager/UserDataInterface;", $i);
                my $section = $child->is_section("()Z");
                if($section)
                {
                my $name = $child->get_data("()Ljava/lang/String;");

                if ($name =~ s/set_block://)
                {
                    if (!$in_set_block)
                    {
                    $in_set_block = 1;
                    print PARAMOUT "---new_set---\n";
                    }
                }
                elsif ($in_set_block)
                {
                    print PARAMOUT "---end_set---\n";
                    $in_set_block = 0;

                }

                my $value = $child->get_data_by_path("(Ljava/lang/String;)Ljava/lang/String;", "value");
                my $type = $child->get_data_by_path("(Ljava/lang/String;)Ljava/lang/String;", "type");

                if ($name =~ /coef_lst_f_\d+/)
                {
                  print COEFF "$value\n";
                }
                elsif ($name =~ /coef_lst_i_\d+/)
                {
                  print COEFI "$value\n";
                }
                else
                {
                  print PARAMOUT "$name : $value\n";
                }
                }
            }
            close $output;
            close $output2;
            close $output3;
            }




         }


                else
                {


            my $output = 'CNXOUT';
                unless( open $output, "> $cnx_file")
            {
            $ePerl->debug("Failed to create $cnx_file");
            return;
            }
                    my $netPro = $ePerl->{PRIVATES}->getPluginPrivateSection("(Ljava/lang/String;)Laltera/ipbu/flowbase/netlist/NetlistPrivateInterface;", $ePerl->{THIS}->getPluginId("()Ljava/lang/String;"));
                    if(netPro)
                    {
                       $pData = $netPro->getPrivateData("()Laltera/ipbu/flowbase/flowmanager/UserDataInterface;");
                       $portData = $ePerl->{PORTS}->getPortData("()Laltera/ipbu/flowbase/flowmanager/UserDataInterface;");
                       my $count = $pData->get_child_count("()I");
                       print CNXOUT "VERSION: WM1.0\n\n";
                       for(my $i = 0; $i < $count; $i++)
                       {
                          my $child = $pData->get_child("(I)Laltera/ipbu/flowbase/flowmanager/UserDataInterface;", $i);
                          my $section = $child->is_section("()Z");
                          if($section)
                          {
                                  my $name = $child->get_data("()Ljava/lang/String;");
                                  my $value = $child->get_data_by_path("(Ljava/lang/String;)Ljava/lang/String;", "value");
                                  my $type = $child->get_data_by_path("(Ljava/lang/String;)Ljava/lang/String;", "type");
                                  if( ("$type" eq "STRING") or ("$type" eq ""))
                                  {
                                          $type = "STRING";
                                  }
                                  else
                                  {
                                          $type = "NUMERIC";
                                  }
                                  print CNXOUT "PRIVATE: $name $type \"$value\"\n";
                          }
                      }
                      close $output;
                    }
                  }

                  #Call command and pass various values
                  my $command = "$wizard $wizard_switches $output_file";

                  $command =~ s/\\/\//g;

                  $ePerl->debug($command);
                  my $runtime = Jvm::call("java/lang/Runtime", "getRuntime", "()Ljava/lang/Runtime;");
                  my $process = $runtime->exec("(Ljava/lang/String;)Ljava/lang/Process;", $command);
                  if(Jvm::exceptionOccurred())
                  {
                    Jvm::exceptionDescribe();
                    return;
                  }
                  $process->waitFor("()I");
                  if(Jvm::exceptionOccurred())
                  {
                    Jvm::exceptionDescribe();
                    return;
                  }
                  my $return_code = $process->exitValue("()I");

                  #run through list of privates and print those in Cnx
                  $ePerl->{THIS}->setActive("(Z)V", 0);
                  if($return_code eq 2 or $return_code eq 3 or $return_code eq 1)
                  {
                          return;
                  }

         if($fir_param_file eq "1")
         {
            my $in_set_block = 0;
             #synchronize privates with constants
             my $input = 'PARAMSIN';
             unless(open $input, "$params_file")
             {
                          $ePerl->debug("Failed to open $params_file");
                          return;
              }

             $portData->empty("()V");
             while(<$input>)
             {
             if(/\s*(\w+)\s+\:\s+(\S+)/)
             {
                 my $name = $1;
                 if ($in_set_block) {
                   $name = "set_block:$name";
                 }
                 my $value = $2;
                 my $prvt = $pData->get_section_by_path("(Ljava/lang/String;)Laltera/ipbu/flowbase/flowmanager/UserDataInterface;", "PRIVATE $name");
                 $prvt->add_child_data("(Ljava/lang/String;Ljava/lang/String;)Z", "type", "string");
                 $prvt->add_child_data("(Ljava/lang/String;Ljava/lang/String;)Z", "value", $value);
             }
             elsif(/---new_set---/)
             {
               $in_set_block = 1;
             }
             elsif (/---end_set---/)
             {
               $in_set_block = 0;
                 }
             }

            close $input;

             my $input = 'COEFF';
             unless(open $input, "$coeff_file")
             {
                          $ePerl->debug("Failed to open $coeff_file");
                          return;
              }

            my $n = 0;
             while(<$input>)
             {
             $n++;
             if (/(.*)/) {
                 my $name = "coef_lst_f_$n";
                 my $value = $1;
                 my $prvt = $pData->get_section_by_path("(Ljava/lang/String;)Laltera/ipbu/flowbase/flowmanager/UserDataInterface;", "PRIVATE $name");
                 $prvt->add_child_data("(Ljava/lang/String;Ljava/lang/String;)Z", "type", "string");
                 $prvt->add_child_data("(Ljava/lang/String;Ljava/lang/String;)Z", "value", $value);
             }
             }

             close $input;
             my $res = unlink $coeff_file;
             $ePerl->debug("Failed to remove $coeff_file") if !$res;


            my $n = 0;
            my $input = 'COEFI';
             unless(open $input, "$coefi_file")
             {
                          $ePerl->debug("Failed to open $coefi_file");
                          return;
              }

             while(<$input>)
             {
            $n++;
             if (/(.*)/) {
                 my $name = "coef_lst_i_$n";
                 my $value = $1;
                 my $prvt = $pData->get_section_by_path("(Ljava/lang/String;)Laltera/ipbu/flowbase/flowmanager/UserDataInterface;", "PRIVATE $name");
                 $prvt->add_child_data("(Ljava/lang/String;Ljava/lang/String;)Z", "type", "string");
                 $prvt->add_child_data("(Ljava/lang/String;Ljava/lang/String;)Z", "value", $value);
             }
            }

        close $input;
            my $res = unlink $coefi_file;
            $ePerl->debug("Failed to remove $coefi_file") if !$res;

        }

                #synchronize privates with constants
                  my $input = 'CNXIN';
                  unless(open $input, "$cnx_file")
                  {
                          $ePerl->debug("Failed to open $cnx_file");
                          return;
                  }
                  $portData->empty("()V");
                  while(<$input>)
                  {
                  if (/\s*MODULE\:\s+(\w+)\s+/)
              {
                  my $module = $1;
                  if ($sub_module eq "1")
                  {
                  $ePerl->{NETLIST}->setModuleNameImplicit("(Ljava/lang/String;)V", "$netlist_top\_sub");
                  }
                  else
                  {
                  $ePerl->{NETLIST}->setModuleNameImplicit("(Ljava/lang/String;)V", "$module");
                  }
              }
                          elsif(/\s*PRIVATE\:\s+(\w+)\s+(\w+)\s+\"*(\S+)\"*/)
                          {
                                  my $value = $3;
                                  my $name = $1;
                                  my $type = $2;
                                  my $prvt = $pData->get_section_by_path("(Ljava/lang/String;)Laltera/ipbu/flowbase/flowmanager/UserDataInterface;", "PRIVATE $name");
                                  if("$type" eq "NUMERIC")
                                  {
                                          $type = "INTEGER";
                                  }
                                  $prvt->add_child_data("(Ljava/lang/String;Ljava/lang/String;)Z", "type", $type);
                                  $prvt->add_child_data("(Ljava/lang/String;Ljava/lang/String;)Z", "value", $value);
                          }
                          elsif(/\s*USED_PORT:\s+(\w+)\s+\d+\s+\d+\s+(\d+)\s+(\d+)\s+(\w+)\s+(\w+)/)
                          {
                                  my $name = $1;
                                  my $dir = $4;
                                  my $high_width = $2;
                                  my $low_width = $3;
                                  my $def_val = $5;
                                  my $prvt = $portData->get_section_by_path("(Ljava/lang/String;)Laltera/ipbu/flowbase/flowmanager/UserDataInterface;", "PORT $name");
                                  $prvt->add_child_data("(Ljava/lang/String;Ljava/lang/String;)Z", "direction", $dir);
                                  $prvt->add_child_data("(Ljava/lang/String;Ljava/lang/String;)Z", "default", $def_val);
                                  if($low_width eq 0)
                                  {
                                      if($high_width eq 0)
                                      {
                                        $high_width = 1;
                                      }
                                      $prvt->add_child_data("(Ljava/lang/String;Ljava/lang/String;)Z", "width", $high_width);
                                  }
                                  else
                                  {
                                    $prvt->add_child_data("(Ljava/lang/String;Ljava/lang/String;)Z", "high_width", $high_width);
                                    $prvt->add_child_data("(Ljava/lang/String;Ljava/lang/String;)Z", "low_width", $low_width);
                                  }
                          }
              }
                  close $input;

          my $res = unlink $params_file;
                  $ePerl->debug("Failed to remove $params_file") if !$res;

               #   my $res = unlink $cnx_file;
               #   $ePerl->debug("Failed to remove $cnx_file") if !$res;

                  $ePerl->debug("DONE $params_file");

                  $ePerl->{NETLIST}->reset("()V");
                  $ePerl->{THIS}->notifyListener("(I)V", $ePerl->{ACTION_UPDATE});
}

sub plugin_deactivate
{
    #Has no control on megawizard
}

sub plugin_refresh
{

}

sub System_Win98_Safe
{
  my (@command_parts) = (@_);
  my $sys_cmd         = join (" ", @command_parts);

  $sys_cmd =~ /^\s*(\S+)\s+(.*)$/ or die
    "System_Win98_Safe: Suspicious system-command: $sys_cmd";

  my $program_path = $1;
  my $arguments    = $2;

  $program_path =~ s|/|\\|g if ($^O =~ /(MSWin|cygwin)/i);

  my $new_sys_cmd = "$program_path $arguments";
  system ($new_sys_cmd);

  my $error_code = ($? >> 8);
  return $error_code;
}

